clear;clc;close all;


ep0 = 3e-1;
ep = 3e-1;
mu = 3e-2;
alpha = 0.85;

load data.mat;
data = data/1e4;
[A,B,T] = size(data);
D = A*B;
v = reshape(data,[D,T]);


addpath ../MOUSSE;
%addpath /Users/jiajihuang/Documents/MATLAB/MOUSSE_petrels_grouse_OPAST/6.11MOUSSE;
trainL = 50;
training = v(:,1:trainL);
[Tr,leafInd,iniRes] = iniTree(training,1,ep0,'petrels_fo','fuzzyc');
% mu0 = mean(iniRes);
% sigma0 = var(iniRes);
clc;

e = [];
numLeaf = [];
Tstats = [];
b = 6;
hit = 50;

figure('Color','white');set(gcf, 'Position', get(0,'Screensize'));
for t = trainL+1:T
    subplot(2,6,[1 3]);
    imagesc(data(:,:,t)*1e4,[0 5e3]);
    axis off;axis image;
    colormap(hot(512));
    title(['Original data t=',num2str(t)],'fontsize',18,'FontWeight','bold');
    
    [Tr,leafInd,ec] = MOUSSE(Tr,leafInd,v(:,t),true(D,1),'petrels_fo',ep,mu,alpha);
    e = [e;ec];


    numLeaf = [numLeaf,length(leafInd)];
    if t<trainL+50
        Tstats = [Tstats,0];
    elseif t==trainL+50
        mu0 = mean(sqrt(e));
        sigma0 = var(sqrt(e));
        Tstats = [Tstats,0];
    elseif t>trainL+50
        Tstats = [Tstats,calStats(sqrt(e(hit(end)+1:end)),mu0,sigma0)];
        if Tstats(end)>b
            hit = [hit,t-trainL];
        end
    end
    
    mindist = inf;
    for i = leafInd
        dist = dist2Node(Tr(i),v(:,t),true(D,1));
        if dist<mindist
            mindist = dist;
            closest = i;
        end
    end
    v_shift = v(:,t)-Tr(closest).center;
    res_t = v_shift-Tr(closest).basis*(Tr(closest).basis'*v_shift);
    res_t = reshape(res_t,[A,B]).^1.1;
    subplot(2,6,[4 6]);
    imagesc(abs(res_t),[0 0.08]);
    axis off;axis image;
    title(['MOUSSE Residual (\gamma corrected) t=',num2str(t)],'fontsize',18,'FontWeight','bold');
    
    
    %%%
    subplot(2,6,[7 8]);plot(trainL+1:t,numLeaf);hold on;plot(t,numLeaf(end),'or');axis([51 300 10 12]);xlabel('t');title('K_t','fontsize',18);myboldify;hold off;
    subplot(2,6,[9 10]);plot(trainL+1:t,e);hold on;plot(t,e(end),'or');axis([51 300 0 7]);xlabel('t');title('e_t','fontsize',18);myboldify;hold off;
    subplot(2,6,[11 12]);plot(trainL+1:t,Tstats);hold on;plot(t,Tstats(end),'or');axis([51 300 0 70]);xlabel('t');title('CUSUM stats','fontsize',18);myboldify;hold off;
    
    %%%
    frame(t-trainL) = getframe(gcf);
end

movie2avi(frame,'solar.avi');